import { visitParents as q, SKIP as F, CONTINUE as M } from "unist-util-visit-parents";
import { BUNDLED_THEMES as A, loadTheme as V, getHighlighter as Y, renderToHtml as S } from "shiki";
import { parseFragment as w } from "parse5";
import { fromParse5 as k } from "hast-util-from-parse5";
const B = (e) => {
  const r = {
    "{": "&#123;",
    "}": "&#125;"
  };
  return e.split("").map((t) => r[t] || t).join("");
}, I = (e) => {
  const t = /^(?<escaped>\s*):(?<token>[\w-]+):(?<content>[\w+\s\S]*)/gm.exec(e);
  if (!t)
    return e;
  const { groups: i } = t, { escaped: s, token: n, content: o } = i;
  if (s.length)
    s.length >= 1;
  else
    return { token: n, content: o };
  return e.substring(1);
}, $ = (e) => {
  const { className: r } = e.properties;
  let t = "";
  for (const i of r)
    if (i.startsWith("language-")) {
      t = i.slice(9);
      break;
    }
  return t;
}, x = async (e, r, t = {
  theme: "dracula",
  inlineCode: !1
}) => {
  const { loadThemes: i, inlineCode: s } = t, n = {};
  if (!A.includes(t.theme) && (!i || !Object.keys(i).includes(t.theme)))
    throw new Error(`Whoopsie! Can't find the theme ${t.theme}`);
  if (i)
    for (const l in i) {
      const h = await V(i[l]);
      n[l] = h;
    }
  const o = A.includes(t.theme) ? t.theme : n[t.theme], a = await Y({
    theme: o
  }), c = a.codeToThemedTokens(e, r);
  return s ? S(c, {
    bg: "#FFFFFF00",
    elements: {
      token: ({ style: l, children: h }) => (h = B(h), t.spaceSubstitution && (h = h.replace(/\s/g, "&nbsp;")), `<span style='${l}'>${h}</span>`),
      pre: ({ children: l }) => `${l}`,
      code: ({ children: l }) => `<code class='rehype-highlighter' data-rh-highlighter-inline data-rh-highlighter-theme='${t.theme}'>${l}</code>`
    }
  }) : S(c, {
    bg: a.getBackgroundColor(),
    elements: {
      token: ({ style: l, children: h }) => `<span style="${l}">${B(h)}</span>`,
      pre: ({ style: l, children: h }) => `<pre data-rh-highlighter-theme='${t.theme}' class='rehype-highlighter' style='${l}'>${h}</pre>`
    }
  });
}, _ = (
  // Note: overloads in JSDoc can’t yet use different `@template`s.
  /**
   * @type {(
   *   (<Condition extends string>(test: Condition) => (node: unknown, index?: number | null | undefined, parent?: Parent | null | undefined, context?: unknown) => node is Node & {type: Condition}) &
   *   (<Condition extends Props>(test: Condition) => (node: unknown, index?: number | null | undefined, parent?: Parent | null | undefined, context?: unknown) => node is Node & Condition) &
   *   (<Condition extends TestFunction>(test: Condition) => (node: unknown, index?: number | null | undefined, parent?: Parent | null | undefined, context?: unknown) => node is Node & Predicate<Condition, Node>) &
   *   ((test?: null | undefined) => (node?: unknown, index?: number | null | undefined, parent?: Parent | null | undefined, context?: unknown) => node is Node) &
   *   ((test?: Test) => Check)
   * )}
   */
  /**
   * @param {Test} [test]
   * @returns {Check}
   */
  function(e) {
    if (e == null)
      return Q;
    if (typeof e == "function")
      return T(e);
    if (typeof e == "object")
      return Array.isArray(e) ? z(e) : G(e);
    if (typeof e == "string")
      return J(e);
    throw new Error("Expected function, string, or object as test");
  }
);
function z(e) {
  const r = [];
  let t = -1;
  for (; ++t < e.length; )
    r[t] = _(e[t]);
  return T(i);
  function i(...s) {
    let n = -1;
    for (; ++n < r.length; )
      if (r[n].apply(this, s))
        return !0;
    return !1;
  }
}
function G(e) {
  const r = (
    /** @type {Record<string, unknown>} */
    e
  );
  return T(t);
  function t(i) {
    const s = (
      /** @type {Record<string, unknown>} */
      /** @type {unknown} */
      i
    );
    let n;
    for (n in e)
      if (s[n] !== r[n])
        return !1;
    return !0;
  }
}
function J(e) {
  return T(r);
  function r(t) {
    return t && t.type === e;
  }
}
function T(e) {
  return r;
  function r(t, i, s) {
    return !!(X(t) && e.call(
      this,
      t,
      typeof i == "number" ? i : void 0,
      s || void 0
    ));
  }
}
function Q() {
  return !0;
}
function X(e) {
  return e !== null && typeof e == "object" && "type" in e;
}
const j = (
  // Note: overloads like this are needed to support optional generics.
  /**
   * @type {(
   *   (<Kind extends UnistParent, Check extends Test>(parent: Kind, index: Child<Kind> | number, test: Check) => Matches<Child<Kind>, Check> | undefined) &
   *   (<Kind extends UnistParent>(parent: Kind, index: Child<Kind> | number, test?: null | undefined) => Child<Kind> | undefined)
   * )}
   */
  /**
   * @param {UnistParent} parent
   * @param {UnistNode | number} index
   * @param {Test} [test]
   * @returns {UnistNode | undefined}
   */
  function(e, r, t) {
    const i = _(t);
    if (!e || !e.type || !e.children)
      throw new Error("Expected parent node");
    if (typeof r == "number") {
      if (r < 0 || r === Number.POSITIVE_INFINITY)
        throw new Error("Expected positive finite number as index");
    } else if (r = e.children.indexOf(r), r < 0)
      throw new Error("Expected child node or index");
    for (; ++r < e.children.length; )
      if (i(e.children[r], r, e))
        return e.children[r];
  }
), y = (
  // Note: overloads in JSDoc can’t yet use different `@template`s.
  /**
   * @type {(
   *   (<Condition extends TestFunction>(test: Condition) => (element: unknown, index?: number | null | undefined, parent?: Parents | null | undefined, context?: unknown) => element is Element & Predicate<Condition, Element>) &
   *   (<Condition extends string>(test: Condition) => (element: unknown, index?: number | null | undefined, parent?: Parents | null | undefined, context?: unknown) => element is Element & {tagName: Condition}) &
   *   ((test?: null | undefined) => (element?: unknown, index?: number | null | undefined, parent?: Parents | null | undefined, context?: unknown) => element is Element) &
   *   ((test?: Test) => Check)
   * )}
   */
  /**
   * @param {Test | null | undefined} [test]
   * @returns {Check}
   */
  function(e) {
    if (e == null)
      return te;
    if (typeof e == "string")
      return ee(e);
    if (typeof e == "object")
      return Z(e);
    if (typeof e == "function")
      return E(e);
    throw new Error("Expected function, string, or array as `test`");
  }
);
function Z(e) {
  const r = [];
  let t = -1;
  for (; ++t < e.length; )
    r[t] = y(e[t]);
  return E(i);
  function i(...s) {
    let n = -1;
    for (; ++n < r.length; )
      if (r[n].apply(this, s))
        return !0;
    return !1;
  }
}
function ee(e) {
  return E(r);
  function r(t) {
    return t.tagName === e;
  }
}
function E(e) {
  return r;
  function r(t, i, s) {
    return !!(ne(t) && e.call(
      this,
      t,
      typeof i == "number" ? i : void 0,
      s || void 0
    ));
  }
}
function te(e) {
  return !!(e && typeof e == "object" && "type" in e && e.type === "element" && "tagName" in e && typeof e.tagName == "string");
}
function ne(e) {
  return e !== null && typeof e == "object" && "type" in e && "tagName" in e;
}
const O = /\n/g, L = /[\t ]+/g, C = y("br"), P = y(he), re = y("p"), W = y("tr"), ie = y([
  // List from: <https://html.spec.whatwg.org/multipage/rendering.html#hidden-elements>
  "datalist",
  "head",
  "noembed",
  "noframes",
  "noscript",
  // Act as if we support scripting.
  "rp",
  "script",
  "style",
  "template",
  "title",
  // Hidden attribute.
  le,
  // From: <https://html.spec.whatwg.org/multipage/rendering.html#flow-content-3>
  ae
]), D = y([
  "address",
  // Flow content
  "article",
  // Sections and headings
  "aside",
  // Sections and headings
  "blockquote",
  // Flow content
  "body",
  // Page
  "caption",
  // `table-caption`
  "center",
  // Flow content (legacy)
  "dd",
  // Lists
  "dialog",
  // Flow content
  "dir",
  // Lists (legacy)
  "dl",
  // Lists
  "dt",
  // Lists
  "div",
  // Flow content
  "figure",
  // Flow content
  "figcaption",
  // Flow content
  "footer",
  // Flow content
  "form,",
  // Flow content
  "h1",
  // Sections and headings
  "h2",
  // Sections and headings
  "h3",
  // Sections and headings
  "h4",
  // Sections and headings
  "h5",
  // Sections and headings
  "h6",
  // Sections and headings
  "header",
  // Flow content
  "hgroup",
  // Sections and headings
  "hr",
  // Flow content
  "html",
  // Page
  "legend",
  // Flow content
  "listing",
  // Flow content (legacy)
  "main",
  // Flow content
  "menu",
  // Lists
  "nav",
  // Sections and headings
  "ol",
  // Lists
  "p",
  // Flow content
  "plaintext",
  // Flow content (legacy)
  "pre",
  // Flow content
  "section",
  // Sections and headings
  "ul",
  // Lists
  "xmp"
  // Flow content (legacy)
]);
function N(e, r = {}) {
  const t = "children" in e ? e.children : [], i = D(e), s = v(e, {
    whitespace: r.whitespace || "normal",
    breakBefore: !1,
    breakAfter: !1
  }), n = [];
  (e.type === "text" || e.type === "comment") && n.push(
    ...R(e, {
      whitespace: s,
      breakBefore: !0,
      breakAfter: !0
    })
  );
  let o = -1;
  for (; ++o < t.length; )
    n.push(
      ...H(
        t[o],
        // @ts-expect-error: `tree` is a parent if we’re here.
        e,
        {
          whitespace: s,
          breakBefore: o ? void 0 : i,
          breakAfter: o < t.length - 1 ? C(t[o + 1]) : i
        }
      )
    );
  const a = [];
  let c;
  for (o = -1; ++o < n.length; ) {
    const l = n[o];
    typeof l == "number" ? c !== void 0 && l > c && (c = l) : l && (c !== void 0 && c > -1 && a.push(`
`.repeat(c) || " "), c = -1, a.push(l));
  }
  return a.join("");
}
function H(e, r, t) {
  return e.type === "element" ? oe(e, r, t) : e.type === "text" ? t.whitespace === "normal" ? R(e, t) : se(e) : [];
}
function oe(e, r, t) {
  const i = v(e, t), s = e.children || [];
  let n = -1, o = [];
  if (ie(e))
    return o;
  let a, c;
  for (C(e) || W(e) && // @ts-expect-error: something up with types of parents.
  j(r, e, W) ? c = `
` : re(e) ? (a = 2, c = 2) : D(e) && (a = 1, c = 1); ++n < s.length; )
    o = o.concat(
      H(s[n], e, {
        whitespace: i,
        breakBefore: n ? void 0 : a,
        breakAfter: n < s.length - 1 ? C(s[n + 1]) : c
      })
    );
  return P(e) && // @ts-expect-error: something up with types of parents.
  j(r, e, P) && o.push("	"), a && o.unshift(a), c && o.push(c), o;
}
function R(e, r) {
  const t = String(e.value), i = [], s = [];
  let n = 0;
  for (; n <= t.length; ) {
    O.lastIndex = n;
    const c = O.exec(t), l = c && "index" in c ? c.index : t.length;
    i.push(
      // Any sequence of collapsible spaces and tabs immediately preceding or
      // following a segment break is removed.
      ce(
        // […] ignoring bidi formatting characters (characters with the
        // Bidi_Control property [UAX9]: ALM, LTR, RTL, LRE-RLO, LRI-PDI) as if
        // they were not there.
        t.slice(n, l).replace(/[\u061C\u200E\u200F\u202A-\u202E\u2066-\u2069]/g, ""),
        n === 0 ? r.breakBefore : !0,
        l === t.length ? r.breakAfter : !0
      )
    ), n = l + 1;
  }
  let o = -1, a;
  for (; ++o < i.length; )
    i[o].charCodeAt(i[o].length - 1) === 8203 || o < i.length - 1 && i[o + 1].charCodeAt(0) === 8203 ? (s.push(i[o]), a = void 0) : i[o] ? (typeof a == "number" && s.push(a), s.push(i[o]), a = 0) : (o === 0 || o === i.length - 1) && s.push(0);
  return s;
}
function se(e) {
  return [String(e.value)];
}
function ce(e, r, t) {
  const i = [];
  let s = 0, n;
  for (; s < e.length; ) {
    L.lastIndex = s;
    const o = L.exec(e);
    n = o ? o.index : e.length, !s && !n && o && !r && i.push(""), s !== n && i.push(e.slice(s, n)), s = o ? n + o[0].length : n;
  }
  return s !== n && !t && i.push(""), i.join(" ");
}
function v(e, r) {
  if (e.type === "element") {
    const t = e.properties || {};
    switch (e.tagName) {
      case "listing":
      case "plaintext":
      case "xmp":
        return "pre";
      case "nobr":
        return "nowrap";
      case "pre":
        return t.wrap ? "pre-wrap" : "pre";
      case "td":
      case "th":
        return t.noWrap ? "nowrap" : r.whitespace;
      case "textarea":
        return "pre-wrap";
    }
  }
  return r.whitespace;
}
function le(e) {
  return !!(e.properties || {}).hidden;
}
function he(e) {
  return e.tagName === "td" || e.tagName === "th";
}
function ae(e) {
  return e.tagName === "dialog" && !(e.properties || {}).open;
}
const ge = (e = {}) => (r) => new Promise((t) => {
  (async () => {
    var o, a, c, l;
    const i = [], n = Object.assign({}, {
      theme: "github-dark",
      inlineCode: {
        spaceSubstitution: !1
      }
    }, e);
    q(r, { tagName: "code" }, (h, p) => {
      const u = p.at(-1);
      return (u == null ? void 0 : u.tagName) === "pre" && h.properties.className && (u == null ? void 0 : u.children.length) == 1 && h.properties.className.some((f) => f.startsWith("language-")) ? (i.push({ node: h, ancestors: p, type: "block" }), F) : (
        /** parseInlineCode function extracts the token(language) from the node.
         * It returns an object if it finds a token else it returns the original 
         * string
        */
        typeof I(N(h)) != "string" && (u == null ? void 0 : u.tagName) !== "pre" ? (i.push({ node: h, ancestors: p, type: "inline" }), F) : M
      );
    });
    for (const { node: h, ancestors: p } of i.filter(({ type: u }) => u === "block")) {
      const u = p.at(-1), f = p.at(-2), g = (o = p.at(-2)) == null ? void 0 : o.children.findIndex((d) => d === u);
      if (g == null)
        return;
      if (typeof n.theme == "string") {
        const d = await x(
          N(h, { whitespace: "pre" }),
          $(h),
          {
            inlineCode: !1,
            theme: n.theme,
            loadThemes: n.loadThemes
          }
        ), b = w(d);
        f.children[g] = k(b.childNodes[0]);
      } else {
        const d = [];
        if (!n.theme || n.theme.length < 1)
          return;
        for (const b of n.theme) {
          const m = await x(
            N(h, { whitespace: "pre" }),
            $(h),
            {
              inlineCode: !1,
              theme: b,
              loadThemes: n.loadThemes
            }
          );
          d.push(
            k(w(m).childNodes[0])
          );
        }
        f == null || f.children.splice(g, 1, ...d);
      }
    }
    for (const { node: h, ancestors: p } of i.filter(({ type: u }) => u === "inline")) {
      const u = ((a = n.inlineCode) == null ? void 0 : a.theme) || n.theme;
      if (!u)
        return;
      const f = p.at(-1), g = f == null ? void 0 : f.children.findIndex((m) => m === h);
      if (g === void 0)
        return;
      const { token: d, content: b } = I(N(h));
      if (typeof u == "string") {
        const m = await x(b, d, {
          inlineCode: !0,
          theme: u,
          loadThemes: n.loadThemes,
          spaceSubstitution: (c = n.inlineCode) == null ? void 0 : c.spaceSubstitution
        });
        f.children[g] = k(w(m));
      } else {
        const m = [];
        for (const K of u) {
          const U = await x(b, d, {
            inlineCode: !0,
            theme: K,
            loadThemes: n.loadThemes,
            spaceSubstitution: (l = n.inlineCode) == null ? void 0 : l.spaceSubstitution
          });
          m.push(
            k(w(U).childNodes[0])
          );
        }
        f == null || f.children.splice(g, 1, ...m);
      }
    }
  })().then(() => t());
});
export {
  ge as default
};
